var proxyNames = new Array(20)
var proxyURLs = new Array(20)
var proxyStyles = new Array(20)
var numProxies = 0

var httproxy = {

  menuItems: new Array("httproxy-view", "httproxy-viewNewTab"),
  linkMenuItems: new Array("httproxy-viewlink", "httproxy-viewlinkNewTab"),
  
  GT_URL: "http://www.google.com/translate?langpair=en|en&u=",
  PROXY_SEP: "##~##",
  DET_SEP: "#~#",
  ANON_STYLE_URL: "A",
  CDN_STYLE_URL: "C",
  
   readOptions: function()
   {
      var prefservice = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
      var prefs = prefservice.getBranch("");
      var proxies = null;
      var proxyList = null;
      var proxyDetails = null;
      var defaultProxy = this.defaultProxy();
      
      if (prefs.getPrefType("extensions.httproxy.proxies") == prefs.PREF_STRING)
        proxies = prefs.getCharPref("extensions.httproxy.proxies");
        
      // separate proxies
      proxyList = proxies ? proxies.split(this.PROXY_SEP) : "";
      
      // separate proxy names and other info
      for (var i = 0; i < proxyList.length && i < 20; i++) {
         if (proxyList[i] != '') {
           proxyDetails = proxyList[i] ? proxyList[i].split(this.DET_SEP) : "";
           proxyNames[i] = proxyDetails[0];
           proxyURLs[i] = proxyDetails[1];
           proxyStyles[i] = proxyDetails[2];
           //alert (i + " " + proxyNames[i] + " " + proxyURLs[i] + " " + proxyStyles[i]);
         }
      }
      numProxies = i;
   },
   
   defaultProxy: function()
   {
      var defaultProxy = -1;
   
      var prefservice = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
      var prefs = prefservice.getBranch("");
      if (prefs.getPrefType("extensions.httproxy.defaultproxy") == prefs.PREF_INT)
        defaultProxy = prefs.getIntPref("extensions.httproxy.defaultproxy");
        
      return defaultProxy;
   },

   startsWith: function(st, pref)
   {
      return( (pref.length > 0) && (st.substring(0, pref.length) == pref) );
        
   },
   
   checkUrl: function(url)
   {
      return ( typeof(url) != 'undefined'
        && url.substr
        && this.startsWith(url, 'http://') );
   },
   
   proxifyURL: function(url, proxyIndex) 
   {
     if (proxyIndex == null)
       proxyIndex = this.defaultProxy();
       
     if (this.checkUrl(url))
     {
       // convert to proxy url
       var proxyURL = proxyURLs[proxyIndex];
       var newUrl = null;
       
       // is this a CDN style proxy
       if (proxyStyles[proxyIndex] == this.ANON_STYLE_URL) {
         newUrl = proxyURLs[proxyIndex] + url;
       }
       else if (proxyStyles[proxyIndex] == this.CDN_STYLE_URL) {
          var myRegEx = new RegExp("^([^:]+:)?/{2,}([^:/]+)(:\[0-9]+)?/(.*)");
          var regExRes = myRegEx.exec(url);
          if (regExRes == null || regExRes[1] != "http:")
              return "error";
              
          // append CDN proxy name as required
          if (regExRes[3] != null) {   // there is a port part
              var port = new String(regExRes[3]).substr(1);
              newUrl = "http://" + regExRes[2] + "." + port + proxyURLs[proxyIndex] + regExRes[4];
          }
          else {
              newUrl = "http://" + regExRes[2] + proxyURLs[proxyIndex] + regExRes[4];
          }
       }
       else
         return "error";
       
       return newUrl;
     }
     else
       return "error";
   },
   
   openURL: function(url, newTab)
   {
     if (newTab)
       gBrowser.addTab(url);
     else
       window._content.location = url;
   },
   
   proxyViewURL: function() 
   {
         var url = document.getElementById('urlbar').value;
         url = this.proxifyURL (url);
         if (url != "error")
           this.openURL(url, false);
         else
           alert ("Invalid URL to be proxied.");
   },
   
   proxyViewURLUsingProxy: function(event) 
   {
         // idnetify and use proxy server properly
         var index = event.target.getAttribute("index");
         if (!index)
           return false;
         
         var url = document.getElementById('urlbar').value;
         url = this.proxifyURL (url, index);
         if (url != "error") {
           this.openURL(url, false);
           return true;
         }
         else {
           alert ("Invalid URL to be proxied.");
           return false;
         }
   },
   
   proxyViewPage: function(newTab) 
   {
         var url = gBrowser.currentURI.spec;
         url = this.proxifyURL (url);
         if (url != "error")
           this.openURL(url, newTab);
         else
           alert ("Invalid URL to be proxied.");
   },
   
   proxyViewLink: function(newTab) 
   {
      if (gContextMenu)
      {
         var url = this.contextLinkURL();
         url = this.proxifyURL (url);
         if (url != "error")
           this.openURL(url, newTab);
         else
           alert ("Invalid URL to be proxied.");
      }
   },

   contextLinkURL: function()
   {
  	if (gContextMenu && gContextMenu.getLinkURL)
	{
		return(gContextMenu.getLinkURL());
	}
	
	return(false);
   },

   readSettingsOptions: function()
   {
      var proxyList = document.getElementById('proxylist');
      this.readOptions();
      
      for (var i = 0; i < numProxies; i++) {
        proxyList.appendItem(proxyNames[i] + " - " + proxyURLs[i]);
      }
      
      proxyList.clearSelection();
      proxyList.selectedIndex = this.defaultProxy();
   },

   setSettingsOptions: function()
   {
      var prefService = Components.classes["@mozilla.org/preferences-service;1"]
                           .getService(Components.interfaces.nsIPrefService);
      var prefs = prefService.getBranch("");
      var proxyList = document.getElementById('proxylist');
      var selected = proxyList.selectedIndex;

      // TODO: Option to add user-defined proxies
/*
      if (this.checkUrl(proxyurl))
      {
        
      }
*/      
      if (selected < 0)
      {
        alert ("Invalid Selection");
        return;
      }
      
      prefs.setIntPref("extensions.httproxy.defaultproxy", selected);
      
      
      // update proxy options - for any change in proxies
      this.readOptions();
      window.close();
   },
   
  FillProxyList: function(event)
  {
    var aParent = event.target;
    
    // Remove old entries if any
    deleteHistoryItems(aParent);
    
    for (var i = 0; i < numProxies; i++) {
      if (i == this.defaultProxy())
        createMenuItem(aParent, i, "** " + proxyNames[i]);
      else
        createMenuItem(aParent, i, proxyNames[i]);
    }

    return true;
  },
   

   httproxyContext: function(aEvent)
   {
      if (gContextMenu)
      {
         var i;
         var menuitem = null;
         
         var anyMenuItemHidden =
           gContextMenu.isTextSelected || // neglect selected text
           gContextMenu.onImage ||        // neglect images
           gContextMenu.onTextInput;      // neglect text input boxes
         var menuItemHidden = 
           gContextMenu.onLink ||         // neglect links
           anyMenuItemHidden ||           
           !this.checkUrl(gBrowser.currentURI.spec); // check URL
         var linkMenuItemHidden =
           !gContextMenu.onLink ||        // only show if link
           anyMenuItemHidden ||
           !this.checkUrl(this.contextLinkURL());   // check Link URL
         
         //Components.utils.reportError("anyMenuItemHidden: " + anyMenuItemHidden);
         //Components.utils.reportError("menuItemHidden: " + menuItemHidden);
         //Components.utils.reportError("linkMenuItemHidden: " + linkMenuItemHidden);
         
         for ( i=0; i < this.menuItems.length; i++)
         {
            menuitem = document.getElementById(this.menuItems[i]);
            if (menuitem)
               menuitem.hidden = menuItemHidden;
         }
         for ( i=0; i < this.linkMenuItems.length; i++)
         {
            menuitem = document.getElementById(this.linkMenuItems[i]);
            if (menuitem)
               menuitem.hidden = linkMenuItemHidden;
         }
      }
   },
   
   onLoad: function() {
      var menu = document.getElementById("contentAreaContextMenu");
      if (menu)
      {
         menu.addEventListener("popupshowing", httproxyContextListener,false);
      }
      // read proxy options
      this.readOptions();
      // initialization code
      this.initialized = true;
   }

};

function httproxyContextListener(e)
{
  return(httproxy.httproxyContext(e));
}

function httproxyInitListener(e)
{
  return(httproxy.onLoad(e));
}

function readSettingsOptions()
{
  alert ("in outer func");
  return (httproxy.readSettingsOptions());
}

window.addEventListener("load", httproxyInitListener, false);
